#  Copyright (C) 2009 Registro.br. All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 1. Redistribution of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY REGISTRO.BR ``AS IS AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIE OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
# EVENT SHALL REGISTRO.BR BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
# OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
# TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
# DAMAGE.
 
class RrType:
	"""RR types codes"""
	A          = 1
	NS         = 2
	CNAME      = 5
	SOA        = 6
	PTR        = 12
	HINFO      = 13
	MINFO      = 14
	MX         = 15
	TXT        = 16
	AAAA       = 28
	LOC        = 29
	SRV        = 33 
	NAPTR      = 35
	CERT       = 37
	DNAME      = 39
	OPT        = 41
	DS         = 43
	SSHFP      = 44
	IPSECKEY   = 45
	RRSIG      = 46
	NSEC       = 47
	DNSKEY     = 48
	NSEC3      = 50
	NSEC3PARAM = 51
	TLSA       = 52
	TSIG       = 250
	
	def __init__(self, name = 'A'):
		"""Default constructor"""
		self.value = getattr(self, name.upper())
			
	def getName(self):
		"""Get the string representation of the RR type"""
		for name in dir(self):
			if (self.value == getattr(self, name)):
				return name
		
		return ""
	
	def __str__(self):
		"""Object's string representation"""
		return self.getName()
